
;definice kernalovych vektoru

cint    = $ff81
ioinit  = $ff84
ramtas  = $ff87
restor  = $ff8a
vector  = $ff8d
setmsg  = $ff90
second  = $ff93
tksa    = $ff96
memtop  = $ff99
membot  = $ff9c
scnkey  = $ff9f
settmo  = $ffa2
acptr   = $ffa5
ciout   = $ffa8
untlk   = $ffab
unlsn   = $ffae
listen  = $ffb1
talk    = $ffb4
readst  = $ffb7
setlfs  = $ffba
setnam  = $ffbd
open    = $ffc0
close   = $ffc3
chkin   = $ffc6
chkout  = $ffc9
clrchn  = $ffcc
chrin   = $ffcf
chrout  = $ffd2
load    = $ffd5
save    = $ffd8
settim  = $ffdb
rdtim   = $ffde
stop    = $ffe1
getin   = $ffe4
clall   = $ffe7
udtim   = $ffea
screen  = $ffed
plot    = $fff0
iobase  = $fff3


hddread   =$def4   ;harddisk routines
hddwrite  =$def1

buffer_lo = $fc
buffer_hi = $fd
 
                   *= $0801
                   
                   .byte $26,$08,$0a,0
                   .byte $9e,"2128:"
                   .byte $8f," D64 TO IDE HDD EXTRACTOR"
                   
                   .byte $00,$41,$08,$14,0,$8f
                   .byte " > BY T.PRIBYL 1998 <",0
                   .byte 0,0,0,0,0

                   *= $0850
                   
                   lda #14
                   jsr chrout ;lowercase
                   lda #$08
                   jsr chrout ;disable SHIFT/CBM
                   
                   lda #$00
                   sta $9d

                   lda #$ff            ;nastaveni priznaku aktivni ctvrtky 0
                   sta act_quarter
                   
                   lda #<d64name
                   ldy #>d64name
                   jsr $ab1e
                   
                   ldy #$00
getarc             jsr chrin
                   sta archivname,y
                   cmp #$0d
                   beq arcnameok
                   iny
                   cpy #$10
                   bne getarc


arcnameok          sty arclen         ;ulozit delku jmena archivu


                   jsr print_dir      ;vytisknout dir
                   

                   lda #$00           ;prohledavat dir od zacatku
                   sta entry
                   
                   lda #18            ;zacatek DIRu pro hledani souboru
                   sta last_dir_trk
                   lda #1
                   sta last_dir_sect
                   

                   lda #<input
                   ldy #>input
                   jsr $ab1e
                   
                   lda #$00
                   sta $99            ;klavesnice vstup


                   ldy #$00
getname            jsr chrin
                   sta extractname,y  ;zadat pattern, co budu extrahovat
                   cmp #$0d
                   beq end_name
                   iny
                   cpy #$10
                   bne getname
                   
end_name           sty exnamelenth

                   ldx #$01           ;disk vstup
                   jsr chkin

                   
extract_next       jsr search_name
                   bcs end_extract
                   
                   jsr extract_file
                   
                   lda #$ff
                   sta act_quarter    ;nacist dir od zacatku
                   jmp extract_next

;------------------------------------------------------

end_extract        lda #$37
                   sta $01
                   lda #$01
                   jsr close
                   lda #$02
                   jsr close
                   jsr clall
                   lda #<end_txt      ;end of extracting
                   ldy #>end_txt
                   jmp $ab1e




;-------------------------------------------------------
; EXTRACT FILE FROM D64
; Vstup: X-sektor
;        Y-stopa
;
; Vystup:soubor na disku
;
;-------------------------------------------------------                   
extract_file       tya
                   pha
                   txa
                   pha        ;ukazatel na prvni sektor souboru schovat

                   lda #$03
                   sta $9a    ;obrazovka

                   ldy #$00
print_sign         lda extr_txt,y   ;tiskne EXTRACTING
                   beq cont
                   jsr chrout
                   iny
                   jmp print_sign


cont               ldy #$00
tiskfile           lda ($bb),y
                   cmp #"/"
                   beq slash
                   cmp #"*"
                   bne notslash
slash              lda #"-"
                   sta ($bb),y
notslash           jsr chrout
                   iny
                   cpy $b7
                   bne tiskfile
                   
                   ldy $b7        ;na konec nazvu prida ,x,W
                   lda ","
                   sta ($bb),y
                   iny
                   lda atribut
                   sta ($bb),y
                   iny
                   lda ","
                   sta ($bb),y
                   iny
                   lda "W"
                   sta ($bb),y
                   iny
                   sty $b7
                   
                   
                   
                   inc $d3    ;posuv kurzoru
                   
                   
                   lda #2     ;cislo souboru 2
                   ldx #12
                   ldy #1     ;otevrit pro zapis
                   jsr setlfs
                   
                   jsr open
                   
                 ;  ldx #$02
                 ;  jsr chkout ;prepnout na vystup
                   
                   pla        ;ukazatel 1. sektoru obnovit
                   tax
                   pla
                   tay

;-----------------------------------------------------                   
cont_extract       jsr read_sector

                   ldx #2
                   jsr chkout
                   
                   lda #$36
                   sta $01
                   
                   ldy #$00
                   lda (buffer_lo),y
                   cmp #$00
                   beq lastsector

                   
;----------------------------------  Ulozit soubor                 
                   ldy #$02
                   
store_block        lda (buffer_lo),y
                   jsr chrout
                   iny
                   cpy #$00
                   bne store_block
                   
                   inc $0427
                   
                   ldy #$00
                   lda (buffer_lo),y
                   pha
                   iny
                   lda (buffer_lo),y
                   tax
                   pla
                   tay
                   jmp cont_extract     ;dalsi sektor precti

;---------------------------------------------------                   
lastsector         ldy #$01
                   lda (buffer_lo),y
                   sta lenth_block
                   inc lenth_block      ;prevod na offset
                   iny
                   

store_last         lda (buffer_lo),y
                   jsr chrout
                   iny
                   cpy lenth_block
                   bne store_last
                   
                   ldy $d3
                   lda #122        ;odtrzitko
                   sta ($d1),y     ;ok
                   
                   lda #$02
                   jsr close                 
                   rts

                   





;-----------------------------------------------------------------------------                   

; TISKNE DIR NA OBRAZOVKU

                   
print_dir          lda #$0d
                   jsr chrout
                   
                   ldx #1
                   ldy #18
                   
next_dir_sect      jsr read_sector    ;nacte 1. sektor diru

                   ldy #$00
                   lda (buffer_lo),y
                   sta next_trk       ;ulozi cislo pristiho TRACKu
                   iny
                   lda (buffer_lo),y
                   sta next_sect      ;ulozi cislo pristiho SECTORu
                   

                   lda #$00
                   sta entry
                   
print_entry        lda entry
                   asl
                   asl
                   asl
                   asl
                   asl
                   sta buffer_lo
                   
                   ldy #$02
                   lda (buffer_lo),y ;00-file deleted
                   beq next_entry
                   
                   and #$0f
                   tay
                   
                   lda type,y
                   jsr chrout
                   
                   lda #$20
                   jsr chrout
                   jsr chrout
                   

                   


                   ldy #$05
printname          lda (buffer_lo),y
                   beq end_of_dir
                   
                   jsr chrout
                   iny
                   cpy #$15
                   bne printname
                   
                   lda #$20
                   jsr chrout
                   
                   ldy #$1e          ;block LOW
                   lda (buffer_lo),y
                   tax
                   iny
                   lda (buffer_lo),y    ;block HIGH
                   jsr $bdcd         ;print BLOCKS
                   
                   lda #$0d
                   jsr chrout  ;odradkuje
                   
next_entry         inc entry   ;dalsi radek v diru
                   lda entry
                   cmp #$08
                   bne print_entry
                   
                   ldy next_trk
                   cpy #$00
                   beq end_of_dir
                   ldx next_sect
                   jmp next_dir_sect
                   


end_of_dir         rts                                      
                   

;--------------------------------------------------------------

; HLEDA JMENO SOUBORU V DIRU PRO EXTRAHOVANI
; Vstup: jmeno souboru, delka jmena
; Vystup: stopa a sektor prvniho bloku

;--------------------------------------------------------------
search_name        ldx last_dir_sect
                   ldy last_dir_trk

next_dir_sect1     jsr read_sector    ;nacte 1. sektor diru

                   ldy #$00
                   lda (buffer_lo),y
                   sta next_trk       ;ulozi cislo pristiho TRACKu
                   iny
                   lda (buffer_lo),y
                   sta next_sect      ;ulozi cislo pristiho SECTORu
                   

                   
new_entry          lda entry
                   asl
                   asl
                   asl
                   asl
                   asl
                   sta buffer_lo
                   


                   ldy #$02
                   lda (buffer_lo),y
                   cmp #$00           ;deleted file skip
                   beq next_search
                   cmp #$80
                   beq next_search    ;DEL file skip too
                   tay
                   lda type,y
                   sta atribut        ;ulozi znak typu souboru
                    
                   ldy #$05
                   ldx #$00
compare_name       lda extractname,x
                   cmp #$2a           ;"*"
                   beq name_ok
                   cmp (buffer_lo),y
                   bne next_search
                   iny
                   inx
                   cpx exnamelenth
                   bne compare_name 
                   
                   
name_ok            ldx #$00
                   ldy #$05
movename           lda (buffer_lo),y
                   cmp #$a0
                   beq endname
                   sta destname,x
                   iny
                   inx
                   cpx #$10
                   bne movename
                   
endname            txa               ;delka jmena
                   ldx #<destname
                   ldy #>destname
                   jsr setnam        ;nastavit originalni jmeno pro EXTRACT
                   
                   inc entry         ;nastavit pro pristi hledani
                   
                   lda entry         ;pokud je jiz v novem sektoru
                   cmp #$08
                   bne ll1

                   lda #$00
                   sta entry
                   lda next_sect     ;musim zazalohovat jiz nove hodnoty
                   sta last_dir_sect
                   lda next_trk
                   sta last_dir_trk
                   jmp ll2
                   
                   
ll1                lda sector        ;schovat sektor, kde jsem prestal hledat
                   sta last_dir_sect
                   lda track         ;schovat stopu, kde jsem prestal hledat
                   sta last_dir_trk

ll2                ldy #$03          ;TRACK
                   lda (buffer_lo),y
                   pha
                   iny               ;SECTOR
                   lda (buffer_lo),y
                   tax               ;start sector of file
                   pla
                   tay               ;start track of file
                   clc
                   rts
                   
                   
                   
next_search        inc entry       ;dalsi radek v diru
                   lda entry
                   cmp #$08
                   beq old
                   jmp new_entry
                   
old                ldy next_trk    ;test, je-li sektor posledni
                   cpy #$00
                   beq end_of_dir1 ;ano, konec
                   
                   ldx next_sect
                   lda #$00
                   sta entry       ;ne, nastav zacatek v sektoru
                   jmp next_dir_sect1
                   
end_of_dir1        sec
                   rts




;---------------------------------------------------------
; rutina READ SECTOR
; vstup: X sektor
;        Y stopa
;
; Vystup: BUFFER_LO/HI ukazatel na sektor v pameti



read_sector        stx sector
                   sty track
                   
                   lda track
                   sec
                   sbc #$01   ;zacatek od 1.tracku
                   
                   asl        ;x2
                   tay
                   
                   
                   lda tracks_start,y
                   sta block_lo
                   lda tracks_start+1,y
                   sta block_hi     ;ulozi pocet sektoru na vsech tracich od
                                    ;zacatku
                   
                   clc              ;a pricte sektory na zadanem tracku
                   lda sector
                   adc block_lo
                   sta block_lo
                   bcc not_cnt
                   inc block_hi

                                    ;block_lo/hi je cislo linearniho sektoru
                   
not_cnt            ldy #$00
                   
divide             sec
                   lda block_lo
                   sbc #$ab         ;vydelim cislo lin. sektoru poctem
                   tax              ;sektoru, co se vejdou naraz do pameti
                   lda block_hi
                   sbc #$00
                   bcc enddiv
                   
                   sta block_hi
                   stx block_lo
                   iny
                   jmp divide

                   
enddiv             sty quarter      ;cislo ctvrtky, ve ktere se nachazi data                  

                   lda block_lo     ;data jsou od $1000
                   clc
                   adc #$10
                   sta block_lo     ;pripoctu
                   
read               ldy quarter
                   cpy act_quarter   ;cislo casti, ktera je v pameti
                   beq quarter_ready ;ctvrtka je READY
                   
                   bcs skip_quarter  ;zadana ctvrtka je za aktualni
                   
                                     ;zadana ctvrtka je pred aktualni,
                   lda #$01          ;soubor musim uzavrit, a cist od zacatku
                   jsr close
                   
                   ldx #<archivname
                   ldy #>archivname
                   lda arclen
                   jsr setnam
                   
                   lda #1
                   ldx #12
                   ldy #0
                   jsr setlfs

                   jsr open          ;znovu otevrit
                   bcs error
                   
                   lda #$00
                   sta act_quarter
                   jmp rdblk
                   
;---------------------------------------------------------------------------
skip_quarter       inc act_quarter   ;zvetsim cislo aktualni ctvrtky v pameti

rdblk              ldx #1
                   jsr chkin
                   
                   lda #$00
                   sta $fa
                   lda #$10
                   sta $fb
                   
                   ldx #$00
                   ldy #$ab          ;nacist 171 bloku do pameti
                   lda #$fa
                   jsr hddread
                   bcs error
                   jmp read          ;nacist dalsich 171 bloku
                   

quarter_ready      lda block_lo      ;ukazatel na sektor v pameti
                   sta buffer_hi
                   lda #$00
                   sta buffer_lo
                   rts
                   

;----------------------------------------------------------------------------


                   
error              lda #$01
                   jsr close
                   jsr clall
                   lda #<err_txt
                   ldy #>err_txt
                   jmp $ab1e







next_trk           .byte 0 
next_sect          .byte 0   ;zaloha odkazu pristiho sektoru


sector             .byte 0   ;cislo sektoru
track              .byte 0
entry              .byte 0

block_lo           .byte 0   ;linearni cislo sektoru
block_hi           .byte 0

quarter            .byte 0   ;0-3 cislo ctvrtky
act_quarter        .byte 0   ;cislo ctvrtky v pameti

exnamelenth        .byte 0   ;delka zadaneho jmena pro extract

last_dir_sect      .byte 0   ;cislo sektoru v diru, kde jsem prestal hledat
last_dir_trk       .byte 0   ;cislo stopy v diru, kde jsem prestal hledat

lenth_block        .byte 0   ;delka posledniho sektoru

arclen             .byte 0   ;delka jmena archivu

atribut            .byte 0   ;priznak typu souboru
;---------------------------------------

type               .text "DSPUR"       ; priznaky souboru


archivname         .text "0123456789ABCDEF" ;misto pro nazev D64 souboru                  

extractname        .text "0123456789ABCDEF" ;misto pro pattern nazvu souboru


destname           .text "0123456789ABCDEF,p,r" ;misto pro cilove jmeno souboru


d64name           .text $93,"d64-ide EXTRACTOR v1.0 BY t.pRIBYL 1998",$0d
                  .text $0d,"iNPUT d64 NAME: ",0

input             .text $0d,"INPUT PATTERN: ",0

extr_txt          .text $0d,"EXTRACTING: ",0

end_txt           .text $0d,$0d,"END OF EXTRACTING...",$0d,0

err_txt           .text $0d,"disk error!!!",0



;----------------------------------------------------------------------
                                ;zacatky tracku v blocich
tracks_start      .byte 0,0     ;track 1      po 21 sektorech na track
                  .byte 21,0    ;track 2
                  .byte 42,0    ;track 3
                  .byte 63,0    ;track 4
                  .byte 84,0    ;track 5
                  .byte 105,0   ;track 6
                  .byte 126,0   ;track 7
                  .byte 147,0   ;track 8
                  .byte 168,0   ;track 9
                  .byte 189,0   ;track 10
                  .byte 210,0   ;track 11
                  .byte 231,0   ;track 12
                  .byte 252,0   ;track 13
                  .byte 17,1    ;track 14    273. blok
                  .byte 38,1    ;track 15
                  .byte 59,1    ;track 16
                  .byte 80,1    ;track 17
                  
                  .byte 101,1   ;track 18     po 19 sektorech na track
                  .byte 120,1   ;track 19
                  .byte 139,1   ;track 20
                  .byte 158,1   ;track 21
                  .byte 177,1   ;track 22
                  .byte 196,1   ;track 23
                  .byte 215,1   ;track 24
                  
                  .byte 234,1   ;track 25    po 18 sektorech
                  .byte 252,1   ;track 26
                  .byte 14,2    ;track 27
                  .byte 32,2    ;track 28
                  .byte 50,2    ;track 29
                  .byte 68,2    ;track 30                      (580)
                  
                  .byte 86,2    ;track 31    po 17 sektorech
                  .byte 103,2   ;track 32
                  .byte 120,2   ;track 33
                  .byte 137,2   ;track 34
                  .byte 154,2   ;track 35    ;                 (666.sektor)
                  